!= ⥸塼
!
!= Initial data generation module
!
! Authors::   Yasuhiro MORIKAWA
! Version::   $Id: initial_data.f90,v 1.2 2007/07/09 11:02:50 morikawa Exp $
! Tag Name::  $Name: dcpam4-20070802 $
! Copyright:: Copyright (C) GFD Dennou Club, 2007. All rights reserved.
! License::   See COPYRIGHT[link:../../COPYRIGHT]
!


module initial_data
  !
  != ⥸塼
  !
  != Initial data generation module
  !
  ! GCM νͤȤʤǡޤ.
  ! եؤνϤϼץǹԤȤꤷƤޤ.
  !
  ! Initial data for GCM is generated.
  ! File output is expected to done by a main program.
  !
  !== Procedures List
  !
  ! Create        :: INIDAT ѿν
  ! Get           :: ͥǡμ
  ! Close         :: INIDAT ѿνλ
  ! PutLine       :: INIDAT ѿ˳ǼƤΰ
  !
  ! Create        :: Constructor of "INIDAT"
  ! Get           :: Get initial data
  ! Close         :: Deconstructor of "INIDAT"
  ! PutLine       :: Print information of "INIDAT"
  !
  !== Usage
  !
  ! Ϥ, INIDAT ѿ, Create ǽԤޤ.
  ! , Get ˤäƽͤɤ߹Ǥ.
  ! Ǹ, INIDAT ѿνλ Close ˤƹԤޤ.
  !
  ! First, initialize "INIDAT" by Create.
  ! Then, get initial data by Get.
  ! Finally, terminate "INIDAT" by Close.
  !

  implicit none
  private
  public:: INIDAT, Create, Get, Close, PutLine

  type INIDAT
    !
    ! ޤ, Create  "INIDAT" ѿꤷƲ.
    ! 줿 "INIDAT" ѿѤݤˤ,
    ! Close ˤäƽλԤäƤ.
    !
    ! Initialize "INIDAT" variable by "Create" before usage.
    ! If you reuse "INIDAT" variable again for another application, 
    ! terminate by "Close".
    !
    logical:: initialized = .false.    ! initialization flag
    integer:: imax ! ٳʻ. 
                   ! Number of grid points in longitude
    integer:: jmax ! ٳʻ. 
                   ! Number of grid points in latitude
    integer:: kmax ! ľؿ. 
                   ! Number of vertical level
  end type INIDAT

  character(*), parameter:: version = &
    & '$Name: dcpam4-20070802 $' // &
    & '$Id: initial_data.f90,v 1.2 2007/07/09 11:02:50 morikawa Exp $'

  interface Create
    module procedure InitialDataCreate
  end interface

  interface Close
    module procedure InitialDataClose
  end interface

  interface PutLine
    module procedure InitialDataPutLine
  end interface

  interface Get
    module procedure InitialDataGet
  end interface

contains

  subroutine InitialDataCreate( ini_dat, &
    & imax, jmax, kmax, &
    & err )
    !
    ! INIDAT ѿνԤޤ.
    ! ¾Υ֥롼ѤɬΥ֥롼ˤä
    ! INIDAT ѿꤷƤ.
    ! ʤ, Ϳ줿 *ini_dat* ˽ꤵƤ,
    ! ץϥ顼ȯޤ.
    !
    ! Constructor of "INIDAT".
    ! Initialize *ini_dat* by this subroutine, 
    ! before other procedures are used, 
    ! Note that if *ini_dat* is already initialized 
    ! by this procedure, error is occurred.
    !
    use dc_trace, only: BeginSub, EndSub
    use dc_types, only: STRING, STDOUT
    use dcpam_error, only: StoreError, DC_NOERR, DCPAM_EALREADYINIT, &
      & DCPAM_ENEGATIVE
    implicit none
    type(INIDAT), intent(inout):: ini_dat
    integer, intent(in):: imax ! ٳʻ. 
                               ! Number of grid points in longitude
    integer, intent(in):: jmax ! ٳʻ. 
                               ! Number of grid points in latitude
    integer, intent(in):: kmax ! ľؿ. 
                               ! Number of vertical level
    logical, intent(out), optional:: err
                              ! 㳰ѥե饰.
                              ! ǥեȤǤ, μ³ǥ顼
                              ! , ץ϶λޤ.
                              !  *err* Ϳ,
                              ! ץ϶λ, 
                              ! *err*  .true. ޤ.
                              !
                              ! Exception handling flag. 
                              ! By default, when error occur in 
                              ! this procedure, the program aborts. 
                              ! If this *err* argument is given, 
                              ! .true. is substituted to *err* and 
                              ! the program does not abort. 
    integer:: stat
    character(STRING):: cause_c
    character(*), parameter:: subname = 'InitialDataCreate'
  continue
    call BeginSub(subname, version)
    stat = DC_NOERR
    cause_c = ''

    !-----------------------------------------------------------------
    !  Υå
    !  Check initialization
    !-----------------------------------------------------------------
    if (ini_dat % initialized) then
      stat = DCPAM_EALREADYINIT
      cause_c = 'INIDAT'
      goto 999
    end if

    !-----------------------------------------------------------------
    !  Υå
    !  Validation of arguments
    !-----------------------------------------------------------------
    if (imax < 1) then
      stat = DCPAM_ENEGATIVE
      cause_c = 'imax'
      goto 999
    end if
    if (jmax < 1) then
      stat = DCPAM_ENEGATIVE
      cause_c = 'jmax'
      goto 999
    end if
    if (kmax < 1) then
      stat = DCPAM_ENEGATIVE
      cause_c = 'kmax'
      goto 999
    end if

    !-----------------------------------------------------------------
    !  ʻ
    !  Configure grid point
    !-----------------------------------------------------------------
    ini_dat % imax = imax
    ini_dat % jmax = jmax
    ini_dat % kmax = kmax

    !-----------------------------------------------------------------
    !  λ, 㳰
    !  Termination and Exception handling
    !-----------------------------------------------------------------
    ini_dat % initialized = .true.
999 continue
    call StoreError(stat, subname, err, cause_c)
    call EndSub(subname)
  end subroutine InitialDataCreate

  subroutine InitialDataClose( ini_dat, err )
    !
    ! INIDAT ѿνλԤޤ.
    ! ʤ, Ϳ줿 *ini_dat*  Create ˤäƽ
    ! Ƥʤ, ץϥ顼ȯޤ.
    !
    ! Deconstructor of "INIDAT".
    ! Note that if *ini_dat* is not initialized by Create yet,
    ! error is occurred.
    !
    use dc_trace, only: BeginSub, EndSub
    use dc_types, only: STRING, STDOUT
    use dcpam_error, only: StoreError, DC_NOERR, DCPAM_ENOTINIT
    implicit none
    type(INIDAT), intent(inout):: ini_dat
    logical, intent(out), optional:: err
                              ! 㳰ѥե饰.
                              ! ǥեȤǤ, μ³ǥ顼
                              ! , ץ϶λޤ.
                              !  *err* Ϳ,
                              ! ץ϶λ, 
                              ! *err*  .true. ޤ.
                              !
                              ! Exception handling flag. 
                              ! By default, when error occur in 
                              ! this procedure, the program aborts. 
                              ! If this *err* argument is given, 
                              ! .true. is substituted to *err* and 
                              ! the program does not abort. 
    integer:: stat
    character(STRING):: cause_c
    character(*), parameter:: subname = 'InitialDataClose'
  continue
    call BeginSub(subname)
    stat = DC_NOERR
    cause_c = ''

    !-----------------------------------------------------------------
    !  Υå
    !  Check initialization
    !-----------------------------------------------------------------
    if (.not. ini_dat % initialized) then
      stat = DCPAM_ENOTINIT
      cause_c = 'INIDAT'
      goto 999
    end if

    !-----------------------------------------------------------------
    !  λ, 㳰
    !  Termination and Exception handling
    !-----------------------------------------------------------------
    ini_dat % initialized = .false.
999 continue
    call StoreError(stat, subname, err, cause_c)
    call EndSub(subname)
  end subroutine InitialDataClose

  subroutine InitialDataPutLine( ini_dat, unit, indent, err )
    !
    !  *ini_dat* ꤵƤޤ.
    ! ǥեȤǤϥåɸϤ˽Ϥޤ. 
    ! *unit* ֹꤹ뤳Ȥ, ѹ뤳ȤǽǤ.
    !
    ! Print information of *ini_dat*.
    ! By default messages are output to standard output.
    ! Unit number for output can be changed by *unit* argument.
    !
    use dc_trace, only: BeginSub, EndSub
    use dc_types, only: STRING, STDOUT
    use dcpam_error, only: StoreError, DC_NOERR, DCPAM_ENOTINIT
    use dc_string, only: Printf
    implicit none
    type(INIDAT), intent(inout):: ini_dat
    integer, intent(in), optional:: unit
                              ! ֹ.
                              ! ǥեȤνϤɸ.
                              !
                              ! Unit number for output.
                              ! Default value is standard output.
    character(*), intent(in), optional:: indent
                              ! ɽåλ.
                              !
                              ! Indent of displayed messages.
    logical, intent(out), optional:: err
                              ! 㳰ѥե饰.
                              ! ǥեȤǤ, μ³ǥ顼
                              ! , ץ϶λޤ.
                              !  *err* Ϳ,
                              ! ץ϶λ, 
                              ! *err*  .true. ޤ.
                              !
                              ! Exception handling flag. 
                              ! By default, when error occur in 
                              ! this procedure, the program aborts. 
                              ! If this *err* argument is given, 
                              ! .true. is substituted to *err* and 
                              ! the program does not abort. 
    integer:: stat
    character(STRING):: cause_c
    integer:: out_unit
    integer:: indent_len
    character(STRING):: indent_str
    character(*), parameter:: subname = 'InitialDataPutLine'
  continue
    call BeginSub(subname)
    stat = DC_NOERR
    cause_c = ''

    !-----------------------------------------------------------------
    !  Υå
    !  Check initialization
    !-----------------------------------------------------------------
    if (present(unit)) then
      out_unit = unit
    else
      out_unit = STDOUT
    end if

    indent_len = 0
    indent_str = ''
    if (present(indent)) then
      if (len(indent) /= 0) then
        indent_len = len(indent)
        indent_str(1:indent_len) = indent
      end if
    end if


    !-----------------------------------------------------------------
    !  "INIDAT" ΰ
    !  Print the settings for "INIDAT"
    !-----------------------------------------------------------------
    if (ini_dat % initialized) then
      call Printf(out_unit, &
        & indent_str(1:indent_len) // &
        & '#<INIDAT:: @initialized=%y @imax=%d @jmax=%d @kmax=%d', &
        & i=(/ini_dat % imax, ini_dat % jmax, ini_dat % kmax/), &
        & l=(/ini_dat % initialized/))
    else
      call Printf(out_unit, &
        & indent_str(1:indent_len) // &
        & '#<INIDAT:: @initialized=%y>', &
        & l=(/ini_dat % initialized/))
    end if


    !-----------------------------------------------------------------
    !  λ, 㳰
    !  Termination and Exception handling
    !-----------------------------------------------------------------
999 continue
    call StoreError(stat, subname, err, cause_c)
    call EndSub(subname)
  end subroutine InitialDataPutLine

  subroutine InitialDataGet( ini_dat, &
    & xyz_VorB, xyz_DivB, xyz_TempB, xyz_QVapB, xy_PsB, &
    & xyz_VorN, xyz_DivN, xyz_TempN, xyz_QVapN, xy_PsN, &
    & err )
    !
    ! GCM Ѥνͥǡ֤ޤ.
    ! , ȯ, , 漾, ɽ̵֤ޤ.
    ! ʬˡȤƥ꡼ץեåꤷ, 
    ! $ t-\Delta t $  $ t $ Υǡ֤ޤ.
    !
    ! ʤ, Ϳ줿 *ini_dat*  Create ˤäƽ
    ! Ƥʤ, ץϥ顼ȯޤ.
    !
    ! Return initial data for GCM.
    ! Vorticity, divergence, temperature, specific humidity, surface pressure
    ! are returned.
    ! Assuming leap-frog scheme as time integration method, 
    ! data at $ t-\Delta t $ and $ t $ is returned.
    !
    ! If *ini_dat* is not initialized by Create yet,
    ! error is occurred.
    !
    use dc_trace, only: BeginSub, EndSub
    use dc_types, only: STRING, STDOUT, DP
    use dcpam_error, only: StoreError, DC_NOERR, DCPAM_ENOTINIT
    implicit none
    type(INIDAT), intent(inout):: ini_dat
    real(DP), intent(out):: xyz_VorB (0:ini_dat%imax-1, 0:ini_dat%jmax-1, 0:ini_dat%kmax-1)
                              ! $ \zeta (t-\Delta t) $ . . Vorticity
    real(DP), intent(out):: xyz_DivB (0:ini_dat%imax-1, 0:ini_dat%jmax-1, 0:ini_dat%kmax-1)
                              ! $ D (t-\Delta t) $ .     ȯ. Divergence
    real(DP), intent(out):: xyz_TempB (0:ini_dat%imax-1, 0:ini_dat%jmax-1, 0:ini_dat%kmax-1)
                              ! $ T (t-\Delta t) $ .     . Temperature
    real(DP), intent(out):: xyz_QVapB (0:ini_dat%imax-1, 0:ini_dat%jmax-1, 0:ini_dat%kmax-1)
                              ! $ q (t-\Delta t) $ .     漾. Specific humidity
    real(DP), intent(out):: xy_PsB (0:ini_dat%imax-1, 0:ini_dat%jmax-1)
                              ! $ P_s (t-\Delta t) $ .   ɽ̵. Surface pressure

    real(DP), intent(out):: xyz_VorN (0:ini_dat%imax-1, 0:ini_dat%jmax-1, 0:ini_dat%kmax-1)
                              ! $ \zeta (t) $ . . Vorticity
    real(DP), intent(out):: xyz_DivN (0:ini_dat%imax-1, 0:ini_dat%jmax-1, 0:ini_dat%kmax-1)
                              ! $ D (t) $ .     ȯ. Divergence
    real(DP), intent(out):: xyz_TempN (0:ini_dat%imax-1, 0:ini_dat%jmax-1, 0:ini_dat%kmax-1)
                              ! $ T (t) $ .     . Temperature
    real(DP), intent(out):: xyz_QVapN (0:ini_dat%imax-1, 0:ini_dat%jmax-1, 0:ini_dat%kmax-1)
                              ! $ q (t) $ .     漾. Specific humidity
    real(DP), intent(out):: xy_PsN (0:ini_dat%imax-1, 0:ini_dat%jmax-1)
                              ! $ P_s (t) $ .   ɽ̵. Surface pressure

    logical, intent(out), optional:: err
                              ! 㳰ѥե饰.
                              ! ǥեȤǤ, μ³ǥ顼
                              ! , ץ϶λޤ.
                              !  *err* Ϳ,
                              ! ץ϶λ, 
                              ! *err*  .true. ޤ.
                              !
                              ! Exception handling flag. 
                              ! By default, when error occur in 
                              ! this procedure, the program aborts. 
                              ! If this *err* argument is given, 
                              ! .true. is substituted to *err* and 
                              ! the program does not abort. 

    !-----------------------------------
    !  ѿ
    !  Work variables
    integer:: imax            ! ٳʻ. 
                              ! Number of grid points in longitude
    integer:: jmax            ! ٳʻ. 
                              ! Number of grid points in latitude
    integer:: kmax            ! ľؿ. 
                              ! Number of vertical level

    integer:: i, j, k         ! DO 롼Ѻѿ
                              ! Work variables for DO loop
    integer:: stat
    character(STRING):: cause_c
    character(*), parameter:: subname = 'InitialDataGet'
  continue
    call BeginSub(subname)
    stat = DC_NOERR
    cause_c = ''

    !-----------------------------------------------------------------
    !  Υå
    !  Check initialization
    !-----------------------------------------------------------------
    if (.not. ini_dat % initialized) then
      stat = DCPAM_ENOTINIT
      cause_c = 'INIDAT'
      goto 999
    end if

    !-----------------------------------------------------------------
    !  *ini_dat* ˳ǼʻμФ
    !  Fetch number of grid points from *ini_dat*
    !-----------------------------------------------------------------
    imax = ini_dat % imax
    jmax = ini_dat % jmax
    kmax = ini_dat % kmax

    !-----------------------------------------------------------------
    !  ͥǡκ
    !  Generate initial data
    !-----------------------------------------------------------------

    !-----------------------------------
    !  AGCM5.3 ΥǥեȽ
    !  AGCM5.3 default initial values
    xyz_VorB = 0.0_DP
    xyz_VorN = 0.0_DP
    xyz_DivB = 0.0_DP
    xyz_DivN = 0.0_DP
    xyz_QVapB = 1.0e-10_DP
    xyz_QVapN = 1.0e-10_DP
    xy_PsB = 1.0e5_DP
    xy_PsN = 1.0e5_DP

    xyz_TempB = 285.0_DP

    do k = 0, kmax - 1
      do i = 0, imax - 1
        do j = 0, jmax - 1
          xyz_TempB(i,j,k) = xyz_TempB(i,j,k) &
            &  + 0.1_DP * sin ( real( i * j * ( kmax - 1 - k ) ) &
            &                  / real( imax * jmax * kmax, DP ) * 10.0_DP &
            &                 )
        end do
      end do
    end do

    xyz_TempN = xyz_TempB


    !-----------------------------------------------------------------
    !  λ, 㳰
    !  Termination and Exception handling
    !-----------------------------------------------------------------
999 continue
    call StoreError(stat, subname, err, cause_c)
    call EndSub(subname)
  end subroutine InitialDataGet

end module initial_data

